%% Microscopy Image Browser Features
% Microscopy Image Browser is a high-performance software package for
% advanced image processing, segmentation and visualization of
% multidimentional (2D-4D) datasets. Microscopy Image Browser is written in
% Matlab, but has a user friendly graphical interface that does not requre
% knowledge of Matlab and can be used by anybody.
%
% Please find a list of main features below
% 
% *Back to* <im_browser_product_page.html *Index*>
%% List of Key Features:
%%
% 
% * Works as a Matlab program under Windows/Linux/MacOS Matlab, or as a standalone application (Windows 64bit)
% * Open source, no license/fee required
% * Extendable with custom plugins (<tutor_programming.html tutorials>)
% * Load/Import multiple image and video formats using standard and custom-made readers, <http://www.mathworks.com Bio-Formats (LOCI) reader>, 
% <http://www.openmicroscopy.org/site OMERO server>, and direct import from
% <http://fiji.sc/Fiji Fiji> and <http://www.bitplane.com Imaris>
% * Generation of multidimentional image stacks (3D/4D, width:height:color:depth:time)
% * Alignment of multi-dimensional stacks and images within these stacks;
% * Brightness, contrast, gamma, image mode adjustments, resize, crop functions, rotate, etc
% * Semi-automatic/manual image segmentation with help of filters and interpolation in XY, XZ, or YZ planes
% * Quantification and statistics for 2D/3D objects
% * Export of images or models to Matlab, <http://www.vsg3d.com/amira/overview Amira> , <http://bio3d.colorado.edu/imod/ IMOD>, <https://youtu.be/G6z0pM3xOIk STL>, TIF, <http://www.slicer.org/ NRRD for 3D Slicer>, <http://imagej.net/BigDataViewer Fiji BigDataViewer> formats
% * Direct 3D visualization using Matlab isosurfaces and volume rendering, <http://fiji.sc/3D_Viewer Fiji 3D viewer>, and <http://www.bitplane.com/ Imaris>
% * Filtering of images with core Matlab and custom functions
% * Log of performed actions 
% * Customizable Undo option
% * Customizable Keyboard shortcuts
% * Colorblind friendly default color modeling scheme
%
%% List of all features
%
% Please check <http://mib.helsinki.fi/features_all.html the list of all features page> for more detailed description and video examples
%
%
%% Scheme of Microscopy Image Browser
%
% Connection diagram of available tools and layers. The opened images may be filtered and adjusted with number of standard/custom 
% functions and further segmented either via the |Mask| route or directly with for example the brush tool and interpolation technique.
%
%%
% 
% <<images/im_browser_scheme.jpg>>
% 
%
% *Back to* <im_browser_product_page.html *Index*>